#include <bits/stdc++.h>

using namespace std;

int main()
{
    long long n, k ,x  ;
    cin >> n >> k >> x  ;
    long long p[n] ;
    for(int i=0 ; i<n ; i++){
        cin >> p[i] ;
    }
    if(x==2){
        for(int i=0 ; i<n-k+1 ; i++){
            long long ms=p[i+k-1] ;
            long long s=p[i+k-1] ;
            int ind=i+k-1 ;
            for(int j=i+k-2 ; j>i ; j--){
                s+=p[j];
                if(s>ms){
                    ms=s ;
                    ind=j ;
                }
            }
            long long a=0 ;
            for(int j=ind-1 ; j>=i ; j--){
                a+=p[j] ;
            }
            cout << max(2*ms+a,s+p[i]) << " " ;
        }
    }
    else{
        for(int i=0 ; i<n-k+1 ; i++){
            long long c=1 ;
            long long s=0 ;
            for(int j=i ; j<k+i ; j++){
                s+=p[j]*c ;
                if(c<x){
                    c++ ;
                }
            }
            cout << s << " " ;
        }
    }
    return 0 ;
}